#include <bits/stdc++.h>

using namespace std;
const int NAJ = 1e3 +9;
int N,Q;
int resenja[NAJ][NAJ];
void racunaj(){
    for(int i = 2; i <= N; i++){
        for(int j = i; j <= N; j++){
            resenja[i][j] = resenja[i-1][j] & resenja[i-1][j-1];
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0),cout.tie(0);
    cin >> N >> Q;
    int niz[Q+1];
    for(int i = 1; i <= N; i++){
        cin >> resenja[1][i];
    }
    racunaj();
    int L,R;
    for(int i = 0; i < Q; i++){
        cin >> L >> R;
        niz[i] = resenja[R-L+1][R];
    }
    for(int i = 0; i < Q; i++){
        cout << niz[i] << endl;
    }
    return 0;
}